/////////////////////////////////////////////////////////////////////////////
// pXݒ_CAO

// vRpCς݃wb_[gp
#include "stdafx.h"

#include "Mary_DelTreeEx.h"
#include "Mary_DelTreeExPathSettingDlg.h"	// pXݒ_CAO



/////////////////////////////////////////////////////////////////////////////
// _CAO vV[W

LRESULT CALLBACK Mary_DelTreeExPathSettingDlgProc( HWND hWnd, UINT msg,
	WPARAM wParam, LPARAM lParam )
{

	CMaryDelTreeExPathSettingDlg* pWnd;
	if( msg == WM_INITDIALOG ){
		pWnd = (CMaryDelTreeExPathSettingDlg*)lParam;
	}
	else{
		pWnd = (CMaryDelTreeExPathSettingDlg*)(LONG_PTR)GetWindowLongPtr( hWnd, GWLP_USERDATA );
		if( pWnd == NULL ){
			return 0;
		}
	}

	switch( msg )
	{
	case WM_INITDIALOG:
		// 
		pWnd->OnInit( hWnd, lParam );
		break;

	case WM_COMMAND:
		// eR}h
		pWnd->OnCommand( wParam, lParam );
		break;

	case WM_PAINT:
		// `揈
		pWnd->OnPaint();
		return TRUE;
		break;

	case WM_CONTEXTMENU:
		// ENbNwv
		pWnd->OnContextMenu( hWnd, wParam, lParam );
		break;

	case WM_HELP:
		// [F1] & [?] wv
		pWnd->OnHelp( hWnd, lParam );
		break;

	case WM_DESTROY:
		// ㏈
		iTRACE("fXg[C(KtK)\n");
		pWnd->OnDestroy();
		break;

	}

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CMaryDelTreeExPathSettingDlg _CAO

CMaryDelTreeExPathSettingDlg::CMaryDelTreeExPathSettingDlg( HWND hWndParent )
{
	// RXgN^
	m_hWnd			= NULL;
	m_hWndParent	= hWndParent;
	m_pMEI			= NULL;
	m_uDelMode		= 0;

	m_hBtnOK			= NULL;
	m_hBtnCancel		= NULL;
	m_hBtnDelTest		= NULL;
	m_hStcPath			= NULL;
	m_hEdtPath			= NULL;
	m_hStcWC			= NULL;
	m_hEdtWC			= NULL;
	m_hChkNDSFolder		= NULL;
	m_hChkNDSFolderFile	= NULL;

}


/////////////////////////////////////////////////////////////////////////////
// fXgN^

CMaryDelTreeExPathSettingDlg::~CMaryDelTreeExPathSettingDlg()
{
	iTRACE("CMaryDelTreeExPathSettingDlg()>fXgN^B\n");
//	m_ctl_IASMary.Stop();

}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy() WM_DESTROY

void CMaryDelTreeExPathSettingDlg::OnDestroy()
{
//	if( m_hLabelIcon != NULL ){
//		DestroyIcon( m_hLabelIcon );
//	}

}


/////////////////////////////////////////////////////////////////////////////
// OnPaint() WM_PAINT

void CMaryDelTreeExPathSettingDlg::OnPaint()
{
	PAINTSTRUCT ps;
	HDC hDC;
	hDC = BeginPaint(m_hWnd, &ps);
	// `揈  ////////////////////////////////////////////////////


	// `揈 ܂ ////////////////////////////////////////////////////
	EndPaint( m_hWnd, &ps );


}


/////////////////////////////////////////////////////////////////////////////
// }[nꂽf[^Zbg

void CMaryDelTreeExPathSettingDlg::SetMEI( MARY_EXTDLL_ITEMDATAW* pMEI )
{
	m_pMEI = pMEI;

}


/////////////////////////////////////////////////////////////////////////////
// f[^Zbg

void CMaryDelTreeExPathSettingDlg::SetLBData( LPCTSTR psPath, MARY_DLL_LB_DATA* pLBD )
{
	m_isPath = psPath;
	m_isWC = pLBD->isWC;
	m_uDelMode = pLBD->uDelMode;
}


/////////////////////////////////////////////////////////////////////////////
// f[^擾

void CMaryDelTreeExPathSettingDlg::GetLBData( CIkoStr* pisPath, MARY_DLL_LB_DATA* pLBD )
{
	*pisPath = m_isPath;
	pLBD->isWC = m_isWC;
	pLBD->uDelMode = m_uDelMode;
}


/////////////////////////////////////////////////////////////////////////////
// eR}h

void CMaryDelTreeExPathSettingDlg::OnCommand( WPARAM wParam, LPARAM lParam )
{
	// eR}h
	HWND hCtl = (HWND)lParam;
	WORD wCtlID = LOWORD(wParam);	// Rg[ID
	WORD wCode = HIWORD(wParam);	// ʒmR[h


	switch( wCtlID )
	{
	case IDOK:
		OnOK();
		break;

	case IDCANCEL:
		OnCancel();
		break;

	case IDC_CHK_ND_SFOLDER:
		OnChkNDSFolder();
		break;

	case IDC_CHK_ND_SFOLDER_FILE:
		OnChkNDSFolderFile();
		break;

	case IDC_BTN_DELTEST:
		OnBtnDelTest();
		break;




	}
}


/////////////////////////////////////////////////////////////////////////////
// _CAO쐬E\

INT_PTR CMaryDelTreeExPathSettingDlg::ShowDlg( void )
{
	// _CAO\
	INT_PTR nRet;
	nRet = DialogBoxParam( g_hDllInst, MAKEINTRESOURCE(IDD_EXTDLL_PATH_SETTING_DLG),
		m_hWndParent, (DLGPROC)Mary_DelTreeExPathSettingDlgProc, (LPARAM)this );
	return nRet;
}


/////////////////////////////////////////////////////////////////////////////
// CMaryDelTreeExPathSettingDlg - \O

BOOL CMaryDelTreeExPathSettingDlg::OnInit( HWND hWnd, LPARAM lParam )
{

	// ϐ
	m_hWnd = hWnd;

	// this ۑ
	SetWindowLongPtr( m_hWnd, GWLP_USERDATA, (LONG_PTR)this );

	// }[̃ACef[^ZbgĂȂ΃G[I
	if( m_pMEI == NULL ){
		EndDialog( m_hWnd, IDCANCEL );
		return FALSE;
	}


	// tHgύX
	IkoAllSetFont( m_hWnd, m_pMEI->hDlgFont );


	// eRg[ nh
	m_hBtnOK		= GetDlgItem( m_hWnd, IDOK );
	m_hBtnCancel	= GetDlgItem( m_hWnd, IDCANCEL );
	m_hBtnDelTest	= GetDlgItem( m_hWnd, IDC_BTN_DELTEST );

	m_hStcPath			= GetDlgItem( m_hWnd, IDC_STC_PATH );
	m_hEdtPath			= GetDlgItem( m_hWnd, IDC_EDT_PATH );
	m_hStcWC			= GetDlgItem( m_hWnd, IDC_STC_WC );
	m_hEdtWC			= GetDlgItem( m_hWnd, IDC_EDT_WC );
	m_hChkNDSFolder		= GetDlgItem( m_hWnd, IDC_CHK_ND_SFOLDER );
	m_hChkNDSFolderFile	= GetDlgItem( m_hWnd, IDC_CHK_ND_SFOLDER_FILE );


	// tHg̑傫ɍ킹ĕKvȂg
	int nTextH = 11;		// eLXg̍
	int nMgnCtls = 8;		// eRg[Ԃ̃}[W
	int nMgnWnd = 6;		// EBhE̗]
	int nBtnW = 0;			// {^̕
	int nBtnH = 0;			// {^̍


	RECT rcCWnd = {0,0,0,0};	// ̃NCAgTCY
	GetClientRect( m_hWnd, &rcCWnd );
	int nMaxCWndR = rcCWnd.right;


	// eRg[ ʒu
	RECT rcBtnOK			= {0,0,0,0};
	RECT rcBtnCancel		= {0,0,0,0};
	RECT rcStcPath			= {0,0,0,0};
	RECT rcEdtPath			= {0,0,0,0};
	RECT rcStcWC			= {0,0,0,0};
	RECT rcEdtWC			= {0,0,0,0};
	RECT rcChkNDSFolder		= {0,0,0,0};
	RECT rcChkNDSFolderFile	= {0,0,0,0};
	RECT rcBtnDelTest		= {0,0,0,0};

	IkoGetChildWndRect( m_hBtnOK, &rcBtnOK );
	IkoGetChildWndRect( m_hBtnCancel, &rcBtnCancel );
	IkoGetChildWndRect( m_hStcPath, &rcStcPath );
	IkoGetChildWndRect( m_hEdtPath, &rcEdtPath );
	IkoGetChildWndRect( m_hStcWC, &rcStcWC );
	IkoGetChildWndRect( m_hEdtWC, &rcEdtWC );
	IkoGetChildWndRect( m_hChkNDSFolder, &rcChkNDSFolder );
	IkoGetChildWndRect( m_hChkNDSFolderFile, &rcChkNDSFolderFile );
	IkoGetChildWndRect( m_hBtnDelTest, &rcBtnDelTest );


	UINT uFlags;	// EBhEʒũIvV
	uFlags = SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER | SWP_NOREDRAW;


	nMgnWnd = rcStcPath.left;		// EBhE̗]


	// {^{lɂ
	nBtnW = iRectW( &rcBtnCancel );
	nBtnH = iRectH( &rcBtnCancel );

	RECT rcText = {0,0,0,0};
	CIkoStr isText;
	IkoGetWindowText( m_hBtnCancel, &isText );
	nTextH = IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	nTextH += 2;
	nMgnCtls = nTextH / 2;

	nBtnH = nTextH + nMgnCtls;	// {^ƃGfBbg̍
	if( nBtnH < iRectH( &rcBtnCancel ) ){
		// ftHg{^̕傫
		iTRACE(_T(">ftHg{^̕傫 ()B\n"));
		nBtnH = iRectH( &rcBtnCancel );
	}

	nBtnW = iRectW( &rcText ) + nBtnH;
	if( nBtnW < iRectW( &rcBtnCancel ) ){
		// ftHg{^̕傫
		iTRACE(_T(">ftHg{^̕傫 ()B\n"));
		nBtnW = iRectW( &rcBtnCancel );
	}

	// pX GfBbg{bNX̉
	int nEdtPathW = nBtnW * 4;

	if( nEdtPathW < iRectW( &rcEdtPath ) ){
		// ftHg̕傫
		nEdtPathW = iRectW( &rcEdtPath );
	}


	// pX eLXg
	IkoGetWindowText( m_hStcPath, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );

	SetWindowPos( m_hStcPath, NULL,
		nMgnWnd, nMgnWnd,
		iRectW( &rcText ) + 2, iRectH( &rcText ) + 2, uFlags );
	IkoGetChildWndRect( m_hStcPath, &rcStcPath );


	// pX GfBbg{bNX
	SetWindowPos( m_hEdtPath, NULL,
		nMgnWnd, rcStcPath.bottom + nMgnCtls,
		nEdtPathW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hEdtPath, &rcEdtPath );


	// ChJ[h eLXg
	IkoGetWindowText( m_hStcWC, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );

	SetWindowPos( m_hStcWC, NULL,
		nMgnWnd, rcEdtPath.bottom + nMgnCtls,
		iRectW( &rcText ) + 2, nBtnH, uFlags );
	IkoGetChildWndRect( m_hStcWC, &rcStcWC );



	// ChJ[h GfBbg{bNX
	int nEdtWCW = (int)(nBtnW * 1.5);
	if( nEdtWCW < iRectW( &rcEdtWC ) ){
		// ftHg̕傫
		nEdtWCW = iRectW( &rcEdtWC );
	}

	SetWindowPos( m_hEdtWC, NULL,
		rcStcWC.right + nMgnCtls, rcStcWC.top,
		iRectW( &rcText ) + 2, nBtnH, uFlags );
	IkoGetChildWndRect( m_hEdtWC, &rcEdtWC );


	// `FbN{bNX TCY
	SIZE szCB;
	if( !IkoChkGetSize( &szCB ) ){
		szCB.cy = nTextH;
		szCB.cx = nTextH;
	}


	// TutH_͎c
	IkoGetWindowText( m_hChkNDSFolder, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	SetWindowPos( m_hChkNDSFolder, NULL,
		nMgnWnd, rcStcWC.bottom + nMgnCtls,
		iRectW( &rcText ) + szCB.cy + nTextH, iRectH( &rcText ) + 2, uFlags );
	IkoGetChildWndRect( m_hChkNDSFolder, &rcChkNDSFolder );


	// TutH_̒gc
	IkoGetWindowText( m_hChkNDSFolderFile, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	SetWindowPos( m_hChkNDSFolderFile, NULL,
		nMgnWnd + nTextH, rcChkNDSFolder.bottom + nMgnCtls,
		iRectW( &rcText ) + szCB.cy + nTextH, iRectH( &rcText ) + 2, uFlags );
	IkoGetChildWndRect( m_hChkNDSFolderFile, &rcChkNDSFolderFile );


	// EBhẺ
	int nCWndW = rcEdtPath.right + nMgnWnd;
	if( rcEdtPath.right < rcEdtWC.right ){
		nCWndW = rcEdtWC.right + nMgnWnd;
	}


	// [LZ] {^
	SetWindowPos( m_hBtnCancel, NULL,
		nCWndW - nMgnWnd - nBtnW, rcChkNDSFolderFile.bottom + ( nMgnCtls * 2 ),
		nBtnW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnCancel, &rcBtnCancel );


	// [OK] {^
	SetWindowPos( m_hBtnOK, NULL,
		rcBtnCancel.left - nBtnW - ( nMgnCtls * 2 ), rcBtnCancel.top,
		nBtnW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnOK, &rcBtnOK );


	// [폜eXg] {^
	IkoGetWindowText( m_hBtnDelTest, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	SetWindowPos( m_hBtnDelTest, NULL,
		nMgnWnd, rcBtnCancel.top,
		iRectW( &rcText ) + nBtnH, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnDelTest, &rcBtnDelTest );


	// ŏIIȃEBhETCY
	int nCWndH = rcBtnCancel.bottom + nMgnWnd;

	IkoSetClientSize( m_hWnd, nCWndW, nCWndH );


	////////////////////////////////////////////////////////
	// f[^Zbg

	// oX
	SetWindowText( m_hEdtPath, m_isPath );

	// ChJ[h
	if( m_isWC.IsEmpty() ){
		SetWindowText( m_hEdtWC, _T("*.*") );
	}
	else{
		SetWindowText( m_hEdtWC, m_isWC );
	}

	// 폜[h
	if( m_uDelMode == 0 ){
		// ׂč폜
		IkoChkSetCheck( m_hChkNDSFolder, 0 );
		IkoChkSetCheck( m_hChkNDSFolderFile, 0 );
	}
	else if( m_uDelMode == 1 ){
		// TutH_͎c
		IkoChkSetCheck( m_hChkNDSFolder, 1 );
		IkoChkSetCheck( m_hChkNDSFolderFile, 0 );
	}
	else{// if( m_pLBD->uDelMode == 2 ){
		// TutH_̒gc
		IkoChkSetCheck( m_hChkNDSFolder, 1 );
		IkoChkSetCheck( m_hChkNDSFolderFile, 1 );
	}


	// pX̍Ō\
//	SetFocus( m_hEdtPath );
	IkoEdtSetSel( m_hEdtPath, 0, -1 );
	IkoEdtSetSel( m_hEdtPath, -1, -1 );


	// EBhE𒆉
	IkoCenterWindow( m_hWnd );

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// [OK] {^

void CMaryDelTreeExPathSettingDlg::OnOK()
{
	iT(_T("[OK] {^B\n"));

	CIkoStr isGetPath;
	CIkoStr isGetWC;

	IkoGetWindowText( m_hEdtPath, &isGetPath );
	IkoGetWindowText( m_hEdtWC, &isGetWC );

	isGetPath.Trim(_T(" \""));
	isGetWC.Trim(_T(" \""));

	m_isPath = isGetPath;
	m_isWC = isGetWC;

	m_uDelMode = GetDelMode();


	EndDialog( m_hWnd, IDOK );
}


/////////////////////////////////////////////////////////////////////////////
// [LZ] {^

void CMaryDelTreeExPathSettingDlg::OnCancel()
{
	iT(_T("[LZ] {^B\n"));
	EndDialog( m_hWnd, IDCANCEL );
}


/////////////////////////////////////////////////////////////////////////////
// TutH_͎c `FbN{bNX

void CMaryDelTreeExPathSettingDlg::OnChkNDSFolder()
{
	iT(_T("TutH_͎c `FbN{bNX\n"));
	if( IkoChkGetCheck( m_hChkNDSFolder ) == 0 ){
		// It
		IkoChkSetCheck( m_hChkNDSFolderFile, 0 );
	}
	else{
		// I
	}
}


/////////////////////////////////////////////////////////////////////////////
// TutH_̒gc `FbN{bNX

void CMaryDelTreeExPathSettingDlg::OnChkNDSFolderFile()
{
	iT(_T("TutH_̒gc `FbN{bNX\n"));
	if( IkoChkGetCheck( m_hChkNDSFolderFile ) == 0 ){
		// It
	}
	else{
		// I
		IkoChkSetCheck( m_hChkNDSFolder, 1 );
	}
}


/////////////////////////////////////////////////////////////////////////////
// [폜eXg] {^ IDC_BTN_DELTEST

void CMaryDelTreeExPathSettingDlg::OnBtnDelTest()
{
	if( GetKeyState( VK_SHIFT ) < 0 || GetKeyState( VK_RBUTTON ) < 0 ){
		// Shift L[Ă
		// E{^Ă
//		IkoMsgBox( _T("Shift L[E{^Ă܂B"), _T("eXg") );
//		return;
	}
	else{
		// ĂȂ̂ŊmF
		if( IkoMsgBox( IDS_EX_PDMB_MES_1, IDS_STR_LABEL_TITLE, MB_YESNO | MB_ICONQUESTION, m_hWnd, NULL, g_hDllInst ) != IDYES ){
			iT(_T("폜 LZI\n"));
			return;
		}
	}


	CIkoStr isDelPath;
	CIkoStr isDelWC;
	UINT uDelMode = 0;

	if( !isDelPath.GetWndText( m_hEdtPath ) ){
		// G[
		IkoMsgBox( IDS_EX_PDMB_MES_2, IDS_STR_LABEL_TITLE, MB_OK | MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
		return;
	}

	if( !isDelWC.GetWndText( m_hEdtWC ) ){
		// G[
		IkoMsgBox( IDS_EX_PDMB_MES_3, IDS_STR_LABEL_TITLE, MB_OK | MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
		return;
	}

	if( isDelWC.IsEmpty() ){
		isDelWC = _T("*.*");
	}

	uDelMode = GetDelMode();


	if( DTEDelTreeEx( isDelPath, isDelWC, uDelMode ) ){
		// 폜
		IkoMsgBox( IDS_EX_PDMB_MES_DELTRUE, IDS_STR_LABEL_TITLE, MB_OK | MB_ICONINFORMATION, m_hWnd, NULL, g_hDllInst );
	}
	else{
		// 폜s
		IkoMsgBox( IDS_EX_PDMB_MES_DELFALSE, IDS_STR_LABEL_TITLE, MB_OK | MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
	}



}


/////////////////////////////////////////////////////////////////////////////
// GetDelMode() ݂̃`FbN{bNX uDelMode 擾

UINT CMaryDelTreeExPathSettingDlg::GetDelMode()
{
	UINT uRet = 0;
	int nChkNDSFolder = IkoChkGetCheck( m_hChkNDSFolder );
	int nChkNDSFolderFile = IkoChkGetCheck( m_hChkNDSFolderFile );
	if( nChkNDSFolder == 0 ){
		// ׂč폜
		uRet = 0;
	}
	else if( nChkNDSFolder == 1 && nChkNDSFolderFile == 0 ){
		// TutH_͎c
		uRet = 1;
	}
	else if( nChkNDSFolderFile == 1 ){
		// TutH_̒gc
		uRet = 2;
	}
	else{
		// ׂč폜
		uRet = 0;
	}

	return uRet;
}



/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// EBhEŉENbN

void CMaryDelTreeExPathSettingDlg::OnContextMenu( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	iTRACE(_T("}EXENbN (OnContextMenu)B\n"));
//	if( m_ctlDTELBItem.IsItemDrag() ){
//		// XgACehbO͉Ȃ
//		return;
//	}

	HWND hCtlWnd = (HWND)wParam;
	POINT ptPos = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };

	// ^Cgo[̏ȂVXej[\
	if( IkoIsPtInTitleBar( m_hWnd, &ptPos ) ){
		iTRACE("OnContextMenu()>^Cgo[ŃNbN܂B\n" );
		return;
	}
	else{
		HELPINFO hi;
		hi.cbSize = sizeof(HELPINFO);
		hi.iContextType = HELPINFO_WINDOW;
		hi.iCtrlId = GetDlgCtrlID( hCtlWnd );
		hi.hItemHandle = hCtlWnd;
		hi.dwContextId = 0;
		hi.MousePos = ptPos;

		OnHelp( hWnd, (LPARAM)&hi );
	}
}


/////////////////////////////////////////////////////////////////////////////
// F1 & [?] J[\ (󋵈ˑ) wv

BOOL CMaryDelTreeExPathSettingDlg::OnHelp( HWND hWnd, LPARAM lParam )
{
	iTRACE("[WM_HELP]\n");

	HELPINFO* phi = (HELPINFO*)lParam;
	HWND hCtlWnd = (HWND)phi->hItemHandle;

	iTRACE(_T("OnHelpInfo()>iCtrlId:[%i],dwContextId:[%i],MousePos:[%i],[%i]\n"),
		phi->iCtrlId, phi->dwContextId, phi->MousePos.x, phi->MousePos.y);

	// ̃_CAO`FbN
	HWND hParWnd = GetAncestor( hCtlWnd, GA_PARENT );
	if( hCtlWnd != m_hWnd && hParWnd != m_hWnd ){
		iTRACE(_T("OnHelpInfo()>̃_CAǑĂяoł͂܂B\n"));
		return FALSE;
	}

	int nCtrlID = 0;
	if( hCtlWnd == m_hWnd ){
		POINT ptCPt = phi->MousePos;
		ScreenToClient( m_hWnd, &ptCPt );
		HWND hPtWnd = ChildWindowFromPoint( m_hWnd, ptCPt );
		if( hPtWnd == NULL ){
			iTRACE(_T("ChildWindowFromPoint() sB\n"));
			return TRUE;
		}
		iTRACE(_T("OnHelpInfo()>_CAOB%i,%i,%i,%i\n"),
			phi->MousePos.x, phi->MousePos.y, ptCPt.x, ptCPt.y );
		if( hPtWnd == m_hWnd ){
			iTRACE(_T("OnHelpInfo()>eEBhEB\n"));
			return TRUE;
		}
		nCtrlID = GetDlgCtrlID( hPtWnd );
		hCtlWnd = hPtWnd;
	}
	else{
		nCtrlID = GetDlgCtrlID( hCtlWnd );
	}

	POINT ptPos = phi->MousePos;
	if( GetKeyState( VK_F1 ) < 0 ){
		iTRACE(_T("OnHelpInfo()>[F1] L[ɂĂяoB\n"));
		RECT rcItem = { 0, 0, 0, 0 };
		GetWindowRect( hCtlWnd, &rcItem );
		ptPos.x = rcItem.left;
		ptPos.y = rcItem.top;
	}

	iTRACE(_T(">nCtrlID>[%i]\n"),nCtrlID);

	UINT uID = 0;
	switch( nCtrlID ){
		case IDOK:
			uID = IDS_EX_HLP_SD_OK;
			break;
		case IDCANCEL:
			uID = IDS_EX_HLP_SD_CANCEL;
			break;
		case IDC_STC_PATH:
		case IDC_EDT_PATH:
			uID = IDS_EX_HLP_PD_EDT_PATH;
			break;
		case IDC_STC_WC:
		case IDC_EDT_WC:
			uID = IDS_EX_HLP_PD_EDT_WC;
			break;
		case IDC_CHK_ND_SFOLDER:
			uID = IDS_EX_HLP_PD_CHK_ND_SFOLDER;
			break;
		case IDC_CHK_ND_SFOLDER_FILE:
			uID = IDS_EX_HLP_PD_CHK_ND_SFOLDER_FILE;
			break;
		case IDC_BTN_DELTEST:
			uID = IDS_EX_HLP_PD_BTN_DELTEST;
			break;
//		case :
//			uID = ;
//			break;
	}


	// |bvAbvwv\
	if( uID != 0 ){
		IkoHelpPopupWnd( uID, g_hDllInst, &ptPos );
		return TRUE;
	}

	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
