/////////////////////////////////////////////////////////////////////////////
// Mary_DelTreeExItemSettingDlg.cpp : ACeڍאݒ_CAO

// vRpCς݃wb_[gp
#include "stdafx.h"

#include "Mary_DelTreeEx.h"
#include "Mary_DelTreeExListBox.h"
#include "Mary_DelTreeExItemSettingDlg.h"
#include "Mary_DelTreeExPathSettingDlg.h"

#include "Mary_DelTreeExVerDlg.h"	// o[W_CAO


/////////////////////////////////////////////////////////////////////////////
// ACeڍאݒ_CAO vV[W

LRESULT CALLBACK Mary_DelTreeExItemSettingDlgProc(
	HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	CMaryDelTreeExItemSettingDlg* pWnd;
	if( msg == WM_INITDIALOG ){
		pWnd = (CMaryDelTreeExItemSettingDlg*)lParam;
	}
	else{
		pWnd = (CMaryDelTreeExItemSettingDlg*)(LONG_PTR)GetWindowLongPtr( hWnd, GWLP_USERDATA );
		if( pWnd == NULL ){
			return 0;
		}
	}

	switch( msg )
	{
	case WM_INITDIALOG:
		// 
		pWnd->OnInit( hWnd, lParam );
		break;

	case WM_DROPFILES:
		// t@C hbv
		pWnd->OnDropFiles( (HDROP)wParam );
		break;

	case WM_SYSCOMMAND:
		// VXej[
		pWnd->OnSysCommand( wParam, lParam );
		break;

	case WM_COMMAND:
		// eR}h
		pWnd->OnCommand( wParam, lParam );
		break;

//	case WM_NOTIFY:
//		pWnd->OnNotify( wParam, lParam );
//		break;
	case WM_VKEYTOITEM:
		iTRACE("ACeڍאݒ_CAO WM_VKEYTOITEMB\n");
/*
߂l:
AvP[ṼbZ[WɉĎsԂ܂B
߂l -2 ̏ꍇ́AAvP[Vōڂ̑IɊւ邷ׂĂ̓삪AXg {bNXł̓삪ȏKvȂƂ܂B
߂l -1 ̏ꍇ́AXg {bNXL[Xg[NɉĊ̓sKv邱Ƃ܂B
߂l 0 ȏ̏ꍇ́A̒l̓Xg {bNX̍ڂ 0 n܂CfbNXԍӖAXg {bNX̍ڂł̃L[Xg[NɉĊ̓s邱Ƃ܂B
*/
		return -1;
		break;
	case WM_KEYDOWN:
		iTRACE("ACeڍאݒ_CAO WM_KEYDOWNB\n");
		pWnd->OnKeyDown( wParam, lParam );
		break;

	case WM_PAINT:
		// `揈
		pWnd->OnPaint();
		return TRUE;
		break;

	case WM_MEASUREITEM:
		pWnd->OnMeasureItem( (UINT)wParam, (LPMEASUREITEMSTRUCT)lParam );
		break;

	case WM_DRAWITEM:
		pWnd->OnDrawItem( (UINT)wParam, (LPDRAWITEMSTRUCT)lParam );
		return 1;	// ȏ`悳Ȃ 0 ȊOԂ
		break;

	case WM_CTLCOLORLISTBOX:
		// Xg{bNX̔wiF
		break;

	case WM_CONTEXTMENU:
		// ENbNwv
		pWnd->OnContextMenu( hWnd, wParam, lParam );
		break;

	case WM_HELP:
		// [F1] & [?] wv
		pWnd->OnHelp( hWnd, lParam );
		break;

	case WM_DESTROY:
		// ㏈
		iTRACE("fXg[C(KtK)\n");
		pWnd->OnDestroy();
		break;
	}

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CMaryDelTreeExItemSettingDlg _CAO

CMaryDelTreeExItemSettingDlg::CMaryDelTreeExItemSettingDlg( HWND hWndParent )
{
	// RXgN^
	m_hWnd			= NULL;
	m_hWndParent	= hWndParent;
	m_pMEI			= NULL;

	m_hLabelIcon	= NULL;

	m_hBtnOK		= NULL;
	m_hBtnCancel	= NULL;
	m_hBtnWebHelp	= NULL;

	m_hStcWait		= NULL;		// [ҋ@b] eLXg
	m_hEdtWait		= NULL;		// [ҋ@b] GfBbg{bNX
	m_hSpnWait		= NULL;		// [ҋ@b] XsRg[
	m_hChkSkip		= NULL;		// [XLbv] `FbN{bNX
	m_hChkOchaRun	= NULL;		// [] `FbN{bNX

	m_hStcTitle	= NULL;
	m_hEdtTitle	= NULL;
	m_hGBList	= NULL;
	m_hEdtPath	= NULL;
	m_hBtnAdd	= NULL;
	m_hBtnDel	= NULL;
	m_hLCItem	= NULL;

	m_hIconGB	= NULL;		// ݔACR
	m_hChkGB	= NULL;		// [ݔɂ] `FbN{bNX

	m_hStcLine	= NULL;

	m_bComInit	= FALSE;	// COM Ă TRUE

}


/////////////////////////////////////////////////////////////////////////////
// fXgN^

CMaryDelTreeExItemSettingDlg::~CMaryDelTreeExItemSettingDlg()
{
	iTRACE("CMaryDelTreeExItemSettingDlg()>fXgN^B\n");
//	m_ctl_IASMary.Stop();

}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy() WM_DESTROY

void CMaryDelTreeExItemSettingDlg::OnDestroy()
{
	iTRACE("CMaryDelTreeExItemSettingDlg()>WM_DESTROYB\n");
	if( m_hLabelIcon != NULL ){
		DestroyIcon( m_hLabelIcon );
	}

	if( m_hIconGB != NULL ){
		DestroyIcon( m_hIconGB );
	}


	// XǧŗLf[^폜
	int nMax = m_ctlLBItem.GetItemCount();
	if( nMax >= 1 ){
		int i = 0;
		while( i < nMax ){
			iT(_T("XǧŗLf[^폜[%i]/[%i]..."),i+1,nMax);
			MARY_DLL_LB_DATA* pmdld = (MARY_DLL_LB_DATA*)m_ctlLBItem.GetItemData( i );
			if( pmdld != NULL ){
				iT(_T("폜I\n"));
				delete pmdld;	// ŗLf[^폜
			}
			else{
				iT(_T("f[^I\n"));
			}
			i++;
		}


	}


	if( m_bComInit ){
		CoUninitialize();
	}


}


/////////////////////////////////////////////////////////////////////////////
// WM_NOTIFY

void CMaryDelTreeExItemSettingDlg::OnNotify( WPARAM wParam, LPARAM lParam )
{
//	iT(_T("[WM_NOTIFY]\n"));
	if( wParam == IDC_LST_ITEM ){
		iT(_T("OnNotify()>IDC_LST_ITEM\n"));
	}

}


/////////////////////////////////////////////////////////////////////////////
// OnPaint() WM_PAINT

void CMaryDelTreeExItemSettingDlg::OnPaint()
{
	PAINTSTRUCT ps;
	HDC hDC;
	hDC = BeginPaint( m_hWnd, &ps );
	// `揈  ////////////////////////////////////////////////////


	// `揈 ܂ ////////////////////////////////////////////////////
	EndPaint( m_hWnd, &ps );
}


/////////////////////////////////////////////////////////////////////////////
// WM_MEASUREITEM

void CMaryDelTreeExItemSettingDlg::OnMeasureItem( UINT nCtlID, LPMEASUREITEMSTRUCT lpMeasureItemStruct )
{
	iT(_T("[WM_MEASUREITEM]\n"));
}


/////////////////////////////////////////////////////////////////////////////
// WM_DRAWITEM Xg{bNX`

void CMaryDelTreeExItemSettingDlg::OnDrawItem( UINT nCtlID, LPDRAWITEMSTRUCT pdi )
{
	// Xg{bNX̕`̓TuNXXg{bNX̕
}


/////////////////////////////////////////////////////////////////////////////
// }[nꂽf[^Zbg

void CMaryDelTreeExItemSettingDlg::SetMEI( MARY_EXTDLL_ITEMDATAW* pMEI )
{
	m_pMEI = pMEI;

}


/////////////////////////////////////////////////////////////////////////////
// t@Chbv

void CMaryDelTreeExItemSettingDlg::OnDropFiles( HDROP hDrop )
{
	// hbvꂽt@C𒲂ׂ
	int nFile = DragQueryFile( hDrop, 0xFFFFFFFF, NULL, 0 );

	int nCurSel = m_ctlLBItem.GetCurSel();
	iT(_T("GetCurSel()>[%i]\n"),nCurSel);
	if( nCurSel <= -1 ){
		nCurSel = -1;
	}
	int nAddCount = 0;
	CIkoStr isDropPath;
	int i = 0;
	while( i < nFile ){
		if( IkoDragQueryFile( hDrop, i, &isDropPath ) ){
			if( IkoIsFolder( isDropPath ) ){
				// tH_Ȃǉ
				if( nCurSel >= 0 ){
					LBAddStr( isDropPath, nCurSel + 1 + nAddCount );
					nAddCount++;
				}
				else{
					// IԂȂ̂ōŌɒǉ
					LBAddStr( isDropPath, -1 );
					nAddCount++;
				}
			}
		}

		i++;
	}

	if( nAddCount >= 1 ){
		iT(_T("SetCurSel()>[%i][%i]\n"),nCurSel,nAddCount );
//		m_ctlLBItem.SetCurSel( nCurSel + nAddCount );
		LBResetEB( nCurSel + nAddCount );
	}

}


/////////////////////////////////////////////////////////////////////////////
// VXej[

void CMaryDelTreeExItemSettingDlg::OnSysCommand( WPARAM wParam, LPARAM lParam )
{

	if( LOWORD(wParam) == IDM_ABOUTBOX ){
		// o[W _CAO\
		CMaryDelTreeExVerDlg dlg( m_hWnd );
		dlg.SetMEI( m_pMEI );
		dlg.ShowDlg();
	}
}


/////////////////////////////////////////////////////////////////////////////
// eR}h

void CMaryDelTreeExItemSettingDlg::OnCommand( WPARAM wParam, LPARAM lParam )
{
	// eR}h
	HWND hCtl = (HWND)lParam;
	WORD wCtlID = LOWORD(wParam);	// Rg[ID
	WORD wCode = HIWORD(wParam);	// ʒmR[h

	switch( wCtlID )
	{
	case IDOK:
		OnOK();
		break;

	case IDCANCEL:
		OnCancel();
		break;

	case IDC_BTN_HELP:
		OnBtnHelp();
		break;

	case IDC_LST_ITEM:
		// Xg{bNX̒ʒm
		OnLstCommand( wCode );
		break;

	case IDC_BTN_ADD:
		// [ǉ] {^
		OnBtnAdd();
		break;

	case IDC_BTN_DEL:
		// [폜] {^
		OnBtnDel();
		break;
	}
}


/////////////////////////////////////////////////////////////////////////////
// WM_KEYDOWN

void CMaryDelTreeExItemSettingDlg::OnKeyDown( WPARAM wParam, LPARAM lParam )
{
	if( GetFocus() == m_ctlLBItem ){
		if( wParam == VK_RETURN ){
			// Xg{bNXł̃L[ (G^[)
			OnBtnItemSetting();
		}
		if( wParam == VK_DELETE ){
			// Xg{bNXł̃L[ (Delete)
			OnBtnDel();
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// _CAO쐬E\

INT_PTR CMaryDelTreeExItemSettingDlg::ShowDlg( void )
{
	// _CAO\
	INT_PTR nRet;
	nRet = DialogBoxParam( g_hDllInst, MAKEINTRESOURCE(IDD_EXTDLL_ITEM_SETTING_DLG),
		m_hWndParent, (DLGPROC)Mary_DelTreeExItemSettingDlgProc, (LPARAM)this );
	return nRet;
}


/////////////////////////////////////////////////////////////////////////////
// CMaryDelTreeExItemSettingDlg - \O

BOOL CMaryDelTreeExItemSettingDlg::OnInit( HWND hWnd, LPARAM lParam )
{
	// ϐ
	m_hWnd = hWnd;

	// this ۑ
	SetWindowLongPtr( m_hWnd, GWLP_USERDATA, (LONG_PTR)this );

	// }[̃ACef[^ZbgĂȂ΃G[I
	if( m_pMEI == NULL ){
		EndDialog( m_hWnd, IDCANCEL );
		return FALSE;
	}

	// COM 
	HRESULT hr = CoInitialize( NULL );
	if( SUCCEEDED(hr) ){
		m_bComInit = TRUE;
	}

	// tHgύX
	IkoAllSetFont( m_hWnd, m_pMEI->hDlgFont );


	// ACR擾
	m_hLabelIcon = dMaryGetLabelIconW();


	// CSIDL_BITBUCKET ݔ
	m_hIconGB = IkoGetSysIcon( CSIDL_BITBUCKET, SHGFI_SMALLICON );


	// eRg[ nh
	m_hBtnOK		= GetDlgItem( m_hWnd, IDOK );
	m_hBtnCancel	= GetDlgItem( m_hWnd, IDCANCEL );
	m_hBtnWebHelp	= GetDlgItem( m_hWnd, IDC_BTN_HELP );

	m_hStcWait		= GetDlgItem( m_hWnd, IDC_STC_WAIT );
	m_hEdtWait		= GetDlgItem( m_hWnd, IDC_EDT_WAIT );
	m_hSpnWait		= GetDlgItem( m_hWnd, IDC_SPN_WAIT );
	m_hChkSkip		= GetDlgItem( m_hWnd, IDC_CHK_SKIP );
	m_hChkOchaRun	= GetDlgItem( m_hWnd, IDC_CHK_OCHARUN );

	m_hIBCIcon.SubclassWnd( IDC_STC_ICON, m_hWnd );
	m_hIBCIcon.SetIcon( m_hLabelIcon );
	m_hIBCIcon.FitWnd();

	m_hStcTitle	= GetDlgItem( m_hWnd, IDC_STC_TITLE );
	m_hEdtTitle	= GetDlgItem( m_hWnd, IDC_EDT_TITLE );
	m_hGBList	= GetDlgItem( m_hWnd, IDC_GB_LIST );
	m_hEdtPath	= GetDlgItem( m_hWnd, IDC_EDT_PATH );
	m_hBtnAdd	= GetDlgItem( m_hWnd, IDC_BTN_ADD );
	m_hBtnDel	= GetDlgItem( m_hWnd, IDC_BTN_DEL );
	m_hLCItem	= GetDlgItem( m_hWnd, IDC_LST_ITEM );

	m_ctlLBItem.SubclassWnd( IDC_LST_ITEM, m_hWnd );
	m_ctlLBItem.SetLabelColor(
		EXTDLL_LABELCOLOR, EXTDLL_LABELWAKUCOLOR, EXTDLL_LABELTEXTCOLOR,
		EXTDLL_LABELSELCOLOR,
		EXTDLL_LABELNFCOLOR, EXTDLL_LABELNFWAKUCOLOR, EXTDLL_LABELNFTEXTCOLOR,
		EXTDLL_LABELNFSELCOLOR
	);
//	m_ctlLBItem.SetBkColor( RGB(100,120,150) );

	m_hIBCIconGB.SubclassWnd( IDC_STC_ICON_GB, m_hWnd );
	m_hIBCIconGB.SetIcon( m_hIconGB );
	m_hIBCIconGB.FitWnd();

	m_hChkGB	= GetDlgItem( m_hWnd, IDC_CHK_GB );

	m_hStcLine	= GetDlgItem( m_hWnd, IDC_STC_LINE );


	// [o[W] j[VXe j[֒ǉ
	HMENU hSysMenu = GetSystemMenu( hWnd, FALSE );
	if( hSysMenu != NULL ){
		TCHAR sStr[64] = {0};
		if( LoadString( g_hDllInst, IDS_ABOUTBOX, sStr, 64 ) != 0 ){
			AppendMenu( hSysMenu, MF_SEPARATOR, 0, 0 );
			AppendMenu( hSysMenu, MF_STRING, IDM_ABOUTBOX, sStr );
		}
	}


	// eRg[ƃEBhETCYύX
	OnResizeCtlWnd();

	// WXgf[^[h
	UINT uErrID = OnLoadRegData();
	if( uErrID != 0 ){
		IkoMsgBox( uErrID, IDS_STR_LABEL_TITLE, MB_OK|MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
	}
	m_ctlLBItem.SetCurSel( 0 );
	LBResetEB();

	// x^Cg
	SetWindowText( m_hEdtTitle, m_pMEI->sTitle );

	// XLbv `FbN{bNX hChkSkip
	if( m_pMEI->bSkip == FALSE ){
		// FALSE Ȃs (XLbvȂ)
		IkoChkSetCheck( m_hChkSkip, 0 );
	}
	else{
		// TRUE ȂXLbv
		IkoChkSetCheck( m_hChkSkip, 1 );
	}


	// bOchaRun g DLL ̂`FbN{bNX̓}[ Ver1.32 ȏ
	int nMaryVer = m_pMEI->nMaryVer;
//	nMaryVer = 131;
	if( nMaryVer >= 132 ){
		// 
		if( m_pMEI->bOchaRun == FALSE ){
			// ߂OɎsȂ (ʏ)
			IkoChkSetCheck( m_hChkOchaRun, 0 );
		}
		else{
			// ߂OɎs
			IkoChkSetCheck( m_hChkOchaRun, 1 );
		}
	}
	else{
		EnableWindow( m_hChkOchaRun, FALSE );
	}


	// EBhE𒆉
	IkoCenterWindow( m_hWnd );

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// eRg[ƃEBhETCYύX

void CMaryDelTreeExItemSettingDlg::OnResizeCtlWnd()
{
	// tHg̑傫ɍ킹ĕKvȂg

	int nTextH = 11;		// eLXg̍
	int nMgnCtls = 8;		// eRg[Ԃ̃}[W
	int nMgnWnd = 6;		// EBhE̗]
	int nBtnW = 0;			// {^̕
	int nBtnH = 0;			// {^̍


	RECT rcCWnd = {0,0,0,0};	// ̃NCAgTCY
	GetClientRect( m_hWnd, &rcCWnd );
	int nMaxCWndR = rcCWnd.right;


	// eRg[ ʒu
	RECT rcBtnOK		= {0,0,0,0};
	RECT rcBtnCancel	= {0,0,0,0};
	RECT rcBtnWebHelp	= {0,0,0,0};

	RECT rcStcWait		= {0,0,0,0};
	RECT rcEdtWait		= {0,0,0,0};
	RECT rcSpnWait		= {0,0,0,0};
	RECT rcChkSkip		= {0,0,0,0};
	RECT rcChkOchaRun	= {0,0,0,0};

	RECT rcIBCIcon		= {0,0,0,0};

	RECT rcStcTitle		= {0,0,0,0};
	RECT rcEdtTitle		= {0,0,0,0};
	RECT rcGBList		= {0,0,0,0};
	RECT rcEdtPath		= {0,0,0,0};
	RECT rcBtnAdd		= {0,0,0,0};
	RECT rcBtnDel		= {0,0,0,0};
	RECT rcLCItem		= {0,0,0,0};

	RECT rcIBCIconGB	= {0,0,0,0};
	RECT rcChkGB		= {0,0,0,0};

	RECT rcStcLine		= {0,0,0,0};

	IkoGetChildWndRect( m_hBtnOK, &rcBtnOK );
	IkoGetChildWndRect( m_hBtnCancel, &rcBtnCancel );
	IkoGetChildWndRect( m_hBtnWebHelp, &rcBtnWebHelp );

	IkoGetChildWndRect( m_hStcWait, &rcStcWait );
	IkoGetChildWndRect( m_hEdtWait, &rcEdtWait );
	IkoGetChildWndRect( m_hSpnWait, &rcSpnWait );
	IkoGetChildWndRect( m_hChkSkip, &rcChkSkip );
	IkoGetChildWndRect( m_hChkOchaRun, &rcChkOchaRun );

	IkoGetChildWndRect( m_hIBCIcon, &rcIBCIcon );

	IkoGetChildWndRect( m_hStcTitle, &rcStcTitle );
	IkoGetChildWndRect( m_hEdtTitle, &rcEdtTitle );
	IkoGetChildWndRect( m_hGBList, &rcGBList );
	IkoGetChildWndRect( m_hEdtPath, &rcEdtPath );
	IkoGetChildWndRect( m_hBtnAdd, &rcBtnAdd );
	IkoGetChildWndRect( m_hBtnDel, &rcBtnDel );
	IkoGetChildWndRect( m_hLCItem, &rcLCItem );

	IkoGetChildWndRect( m_hIBCIconGB, &rcIBCIconGB );
	IkoGetChildWndRect( m_hChkGB, &rcChkGB );

	IkoGetChildWndRect( m_hStcLine, &rcStcLine );


	UINT uFlags;	// EBhEʒũIvV
	uFlags = SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER | SWP_NOREDRAW;


	nMgnWnd = rcStcLine.left;


	// [ǉ] {^{lɂ m_hBtnAdd
	nBtnW = iRectW( &rcBtnAdd );
	nBtnH = iRectH( &rcBtnAdd );

	RECT rcText = {0,0,0,0};
	CIkoStr isText;
	IkoGetWindowText( m_hBtnAdd, &isText );
	nTextH = IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	nMgnCtls = nTextH / 2;

	nBtnH = nTextH + nMgnCtls;	// {^ƃGfBbg̍
	if( nBtnH < iRectH( &rcBtnAdd ) ){
		// ftHg{^̕傫
		iTRACE(_T(">ftHg{^̕傫 ()B\n"));
		nBtnH = iRectH( &rcBtnAdd );
	}

	nBtnW = iRectW( &rcText ) + nBtnH;
	if( nBtnW < iRectW( &rcBtnAdd ) ){
		// ftHg{^̕傫
		iTRACE(_T(">ftHg{^̕傫 ()B\n"));
		nBtnW = iRectW( &rcBtnAdd );
	}


	// ^Cg eLXg
	IkoGetWindowText( m_hStcTitle, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	SetWindowPos( m_hStcTitle, NULL,
		rcIBCIcon.right + ( nMgnCtls * 2 ), rcStcTitle.top,
		iRectW( &rcText ), nBtnH, uFlags );
	IkoGetChildWndRect( m_hStcTitle, &rcStcTitle );


	// Xg{bNX̉͒ǉ{^3
	int nLCItemW = nBtnW * 3;
	// Xg{bNX̍͒ǉ{^5
	int nLCItemH = nBtnH * 5;
	// GfBbg{bNX̉
	int nEdtPathW = nLCItemW + nMgnCtls + nBtnW;

	// O[v{bNX̉
	int nGBListW = nEdtPathW + ( nMgnCtls * 4 );

	// O[v{bNX̍
	int nGBListH = nTextH + nMgnCtls + nBtnH + nMgnCtls + nLCItemH + ( nMgnCtls * 2 );

	// O[v{bNX ʒu
	int nGBListTop = rcIBCIcon.bottom;
	if( rcIBCIcon.bottom < rcStcTitle.bottom ){
		nGBListTop = rcStcTitle.bottom;
	}

	nGBListTop += ( nMgnCtls * 2 );	// O[v{bNX


	// EBhẺ
	int nCWndW = nGBListW + ( nMgnWnd * 2 );
	if( nCWndW < iRectW( &rcCWnd ) ){
		iT(_T("EBhEgB\n"));
		nCWndW = iRectW( &rcCWnd );
	}
	// ^Cg GfBbg{bNX
	int nEdtTitleW = iRectW( &rcEdtTitle );
	if( nEdtTitleW < ( nBtnW * 2 ) ){
		nEdtTitleW = nBtnW * 2;
	}
//	nEdtTitleW = nGBListW + 1;	// fobO
	if( ( rcStcTitle.right + ( nMgnCtls * 2 ) + nEdtTitleW ) > nGBListW ){
		// ͂ݏôŏk
		nEdtTitleW = nCWndW - rcStcTitle.right - ( nMgnCtls * 4 );
	}

	SetWindowPos( m_hEdtTitle, NULL,
		rcStcTitle.right + ( nMgnCtls * 2 ), rcEdtTitle.top,
		nEdtTitleW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hEdtTitle, &rcEdtTitle );


	// O[v{bNX
	SetWindowPos( m_hGBList, NULL,
		nMgnWnd, nGBListTop,
		nGBListW, nGBListH, uFlags );
	IkoGetChildWndRect( m_hGBList, &rcGBList );


	// GfBbg{bNX
	SetWindowPos( m_hEdtPath, NULL,
		nMgnWnd + ( nMgnCtls * 2 ), nGBListTop + nTextH + nMgnCtls,
		nEdtPathW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hEdtPath, &rcEdtPath );


	// Xg{bNX
	SetWindowPos( m_hLCItem, NULL,
		nMgnWnd + ( nMgnCtls * 2 ), rcEdtPath.bottom + nMgnCtls,
		nLCItemW, nLCItemH, uFlags );
	IkoGetChildWndRect( m_hLCItem, &rcLCItem );


	// [ǉ] {^
	SetWindowPos( m_hBtnAdd, NULL,
		rcLCItem.right + nMgnCtls, rcLCItem.top,
		nBtnW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnAdd, &rcBtnAdd );


	// [폜] {^
	SetWindowPos( m_hBtnDel, NULL,
		rcLCItem.right + nMgnCtls, rcLCItem.bottom - nBtnH,
		nBtnW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnDel, &rcBtnDel );


	// [ݔACR]
	SetWindowPos( m_hIBCIconGB, NULL,
		nMgnWnd + nMgnCtls, rcGBList.bottom + nMgnCtls,
		0, 0, uFlags | SWP_NOSIZE );
	IkoGetChildWndRect( m_hIBCIconGB, &rcIBCIconGB );


	// [ݔɂ] `FbN{bNX
	SIZE szChk = {0,0};
	if( !IkoChkGetSize( &szChk ) ){
		szChk.cx = nTextH;
		szChk.cy = nTextH;
	}
	IkoGetWindowText( m_hChkGB, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	SetWindowPos( m_hChkGB, NULL,
		rcIBCIconGB.right + 8, rcGBList.bottom + nMgnCtls,
		iRectW( &rcText ) + szChk.cx + nTextH, iRectH( &rcText ) + 2, uFlags );
	IkoGetChildWndRect( m_hChkGB, &rcChkGB );


	// 
	int nStcLineTop;
	if( rcIBCIconGB.bottom < rcChkGB.bottom ){
		nStcLineTop = rcChkGB.bottom;
	}
	else{
		nStcLineTop = rcIBCIconGB.bottom;
	}
	nStcLineTop += nMgnCtls;

	SetWindowPos( m_hStcLine, NULL,
		nMgnWnd, nStcLineTop,
		iRectW( &rcGBList ), iRectH( &rcStcLine ), uFlags );
	IkoGetChildWndRect( m_hStcLine, &rcStcLine );


	// [ҋ@b] eLXg	m_hStcWait
	IkoGetWindowText( m_hStcWait, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	SetWindowPos( m_hStcWait, NULL,
		nMgnWnd, rcStcLine.bottom + ( nMgnCtls * 2 ),
		iRectW( &rcText ), nBtnH, uFlags );
	IkoGetChildWndRect( m_hStcWait, &rcStcWait );


	// [ҋ@b] GfBbg{bNX	m_hEdtWait
	IkoGetTextH( m_pMEI->hDlgFont, _T("99999"), &rcText );
	SetWindowPos( m_hEdtWait, NULL,
		rcStcWait.right + ( nMgnCtls * 2 ), rcStcWait.top,
		iRectW( &rcText ) + iRectW( &rcSpnWait ), nBtnH, uFlags );
	IkoGetChildWndRect( m_hEdtWait, &rcEdtWait );


	// [ҋ@b] XsRg[	m_hSpnWait
	IkoSpnSetBuddy( m_hSpnWait, m_hEdtWait );
	IkoSpnSetRange32( m_hSpnWait, 0, 99 );
	IkoSpnSetPos( m_hSpnWait, m_pMEI->nWait );
//	SendMessageW( hSpnWait, UDM_SETBUDDY, (WPARAM) hEdtWait, (LPARAM) 0 );
//	SendMessageW( hSpnWait, UDM_SETRANGE32, (WPARAM) 0, (LPARAM) 99 );
//	SendMessageW( hSpnWait, UDM_SETPOS, (WPARAM) 0, (LPARAM) MAKELONG( (short) pmei->nWait, 0 ) );


	// `FbN{bNX̃TCY
	SIZE szCB;
	if( !IkoChkGetSize( &szCB ) ){
		szCB.cy = nTextH;
		szCB.cx = nTextH;
	}

	// [XLbv] `FbN{bNX	m_hChkSkip
	IkoGetWindowText( m_hChkSkip, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText, FALSE );
	SetWindowPos( m_hChkSkip, NULL,
		nMgnWnd, rcStcWait.bottom + ( nMgnCtls * 1 ),
		iRectW( &rcText ) + szCB.cy + nTextH, iRectH( &rcText ) + 2, uFlags );
	IkoGetChildWndRect( m_hChkSkip, &rcChkSkip );


	// [] `FbN{bNX	m_hChkOhaRun
	IkoGetWindowText( m_hChkOchaRun, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText, FALSE );
	int nChkOchaRunTop = rcStcWait.top;
	if( nBtnH < iRectH( &rcText ) + 2 ){
		nChkOchaRunTop = rcStcWait.top -
			( ( ( iRectH( &rcText ) + 2 ) - nBtnH ) / 2 );
	}

	SetWindowPos( m_hChkOchaRun, NULL,
		rcEdtWait.right + ( nMgnCtls * 4 ), nChkOchaRunTop,
		iRectW( &rcText ) + szCB.cy + nTextH, iRectH( &rcText ) + 2, uFlags );
	IkoGetChildWndRect( m_hChkOchaRun, &rcChkOchaRun );



	// [Web wv] {^
	IkoGetWindowText( m_hBtnWebHelp, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	int nBtnWebHelpW = iRectW( &rcText ) + nTextH;
	if( nBtnWebHelpW < iRectW( &rcBtnWebHelp ) ){
		// ̕傫
		iT(_T("[Web wv] {^>̕傫B\n"));
		nBtnWebHelpW = iRectW( &rcBtnWebHelp );
	}
	SetWindowPos( m_hBtnWebHelp, NULL,
		rcStcLine.right - nBtnWebHelpW, rcChkOchaRun.bottom + nMgnCtls,
		nBtnWebHelpW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnWebHelp, &rcBtnWebHelp );


	// [LZ] {^
	IkoGetWindowText( m_hBtnCancel, &isText );
	IkoGetTextH( m_pMEI->hDlgFont, isText, &rcText );
	int nBtnCancelW = iRectW( &rcText ) + nBtnH * 2;
	if( nBtnCancelW < iRectW( &rcBtnCancel ) ){
		// ̕傫
		iT(_T("[LZ] {^>̕傫B\n"));
		nBtnCancelW = iRectW( &rcBtnCancel );
	}
	SetWindowPos( m_hBtnCancel, NULL,
		rcStcLine.right - nBtnCancelW, rcBtnWebHelp.bottom + ( nMgnCtls * 2 ),
		nBtnCancelW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnCancel, &rcBtnCancel );


	// [ۑ] {^
	SetWindowPos( m_hBtnOK, NULL,
		rcBtnCancel.left - nBtnCancelW - ( nMgnCtls * 2 ), rcBtnCancel.top,
		nBtnCancelW, nBtnH, uFlags );
	IkoGetChildWndRect( m_hBtnOK, &rcBtnOK );


	// Xg{bNX1ACe̍
	m_ctlLBItem.SetItemHeight( nBtnH );


	// ŏIIȃEBhETCY
//	nCWndW = iRectW( &rcGBList ) + ( nMgnWnd * 2 );
//	if( nCWndW < iRectW( &rcCWnd ) ){
//		iT(_T("EBhEgB\n"));
//		nCWndW = iRectW( &rcCWnd );
//	}
	int nCWndH = rcBtnCancel.bottom + nMgnWnd;

	IkoSetClientSize( m_hWnd, nCWndW, nCWndH );



}





/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// [ۑ] {^

void CMaryDelTreeExItemSettingDlg::OnOK()
{
	iT(_T("[ۑ] {^B\n"));
	UINT uErrID = OnSaveRegData();
	if( uErrID != 0 ){
		IkoMsgBox( uErrID, IDS_STR_LABEL_TITLE, MB_OK|MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
		return;
	}


	// x^CgAҋ@bAXLbvtOXV
	CIkoStr isLabelTitle;
	isLabelTitle.GetWndText( m_hEdtTitle );
	isLabelTitle.Trim(_T(" @"));
	if( isLabelTitle.IsEmpty() ){
		// x^CgȂftHg^Cgɖ߂
		dMaryGetLabelTitleW( m_pMEI->sTitle );
	}
	else{
		int nBuf = isLabelTitle.GetLen();
		nBuf++;		// NULL ǉ
		if( nBuf >= 101 ){
			nBuf = 100;
		}
		lstrcpyn( m_pMEI->sTitle, isLabelTitle, nBuf );
	}

	// ҋ@b
	int nWait = 0;
	if( IkoSpnGetPos( m_hSpnWait, &nWait ) ){
		m_pMEI->nWait = nWait;
	}
//	else{
//		m_pMEI->nWait = 0;
//	}

	// XLbv `FbN{bNX hChkSkip
	if( IkoChkGetCheck( m_hChkSkip ) == 0 ){
		m_pMEI->bSkip = FALSE;
	}
	else{
		m_pMEI->bSkip = TRUE;
	}


	// bOchaRun `FbN{bNX̓}[ Ver1.32 ȏ
	int nMaryVer = m_pMEI->nMaryVer;
//	nMaryVer = 131;
	if( nMaryVer >= 132 ){
		// 
		if( IkoChkGetCheck( m_hChkOchaRun ) == 0 ){
			// ߂OɎsȂ (ʏ)
			m_pMEI->bOchaRun = FALSE;
		}
		else{
			// ߂OɎs
			m_pMEI->bOchaRun = TRUE;
		}
	}


	EndDialog( m_hWnd, IDOK );

}


/////////////////////////////////////////////////////////////////////////////
// [LZ] {^

void CMaryDelTreeExItemSettingDlg::OnCancel()
{
	iT(_T("[LZ] {^B\n"));
	EndDialog( m_hWnd, IDCANCEL );
}


/////////////////////////////////////////////////////////////////////////////
// [Web wv] {^

void CMaryDelTreeExItemSettingDlg::OnBtnHelp()
{
	iT(_T("[Web wv] {^B\n"));
	// KURUMISROOM_MARY_EXTDLL_HELP
	CIkoStr isWeb;
	ShellExecute( m_hWnd, NULL, KURUMISROOM_MARY_EXTDLL_HELP,
		NULL, NULL, SW_SHOWNORMAL );
}


/////////////////////////////////////////////////////////////////////////////
// [ǉ] {^

void CMaryDelTreeExItemSettingDlg::OnBtnAdd()
{
	iT(_T("[ǉ] {^\n"));

	BROWSEINFO bi;
	memset( &bi, 0, sizeof(BROWSEINFO) );

	CIkoStr isMes;
	isMes.LoadStr( IDS_EX_SD_FDMES, g_hDllInst );
//	iT(_T("[%s]\n"),isMes.t());
	bi.lpszTitle = isMes;
	CIkoStr isPath;
	int nCurSel = m_ctlLBItem.GetCurSel();
	m_ctlLBItem.GetStr( &isPath, nCurSel );
	if( !IkoFolderDlg( m_hWnd, &isPath, &bi, CSIDL_DRIVES ) ){
		// LZ
	iT(_T("[ǉ] {^>LZ\n"));
		return;
	}


	int nSel = LBAddStr( isPath, nCurSel + 1 );

	LBResetEB( nSel );

}


/////////////////////////////////////////////////////////////////////////////
// [폜] {^

void CMaryDelTreeExItemSettingDlg::OnBtnDel()
{
	iT(_T("[폜] {^\n"));
	int nSel = m_ctlLBItem.GetCurSel();
	if( nSel != -1 ){
		// 폜Jn
		MARY_DLL_LB_DATA* pmdld = (MARY_DLL_LB_DATA*)m_ctlLBItem.GetItemData( nSel );
		if( m_ctlLBItem.DelStr( nSel ) ){
			// 폜
			delete pmdld;	// ŗLf[^폜

			int nMaxNo = m_ctlLBItem.GetItemCount();
			nMaxNo--;
			iT(_T("nMaxNo[%i], nSel[%i]\n"),nMaxNo,nSel);
			if( nMaxNo >= 0 ){
				if( nMaxNo < nSel ){
					nSel = nMaxNo;
				}
				m_ctlLBItem.SetCurSel( nSel );
			}
			LBResetEB();
		}
		else{
			// 폜s
			IkoMsgBox( IDS_EX_SDMB_MES_5, IDS_STR_LABEL_TITLE, MB_OK, m_hWnd, NULL, g_hDllInst );

		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// IꂽACe

void CMaryDelTreeExItemSettingDlg::OnBtnItemUp()
{
}


/////////////////////////////////////////////////////////////////////////////
// IꂽACe

void CMaryDelTreeExItemSettingDlg::OnBtnItemDown()
{
}


/////////////////////////////////////////////////////////////////////////////
// XgACeڍאݒ

void CMaryDelTreeExItemSettingDlg::OnBtnItemSetting()
{
	int nSel = m_ctlLBItem.GetCurSel();
	if( nSel == -1 ){
		// ACeI
		return;
	}

	CIkoStr isPath;
	m_ctlLBItem.GetStr( &isPath, nSel );

	MARY_DLL_LB_DATA* pLBD = NULL;
	pLBD = (MARY_DLL_LB_DATA*)m_ctlLBItem.GetItemData( nSel );

	CMaryDelTreeExPathSettingDlg dlg( m_hWnd );
	dlg.SetMEI( m_pMEI );
	dlg.SetLBData( isPath, pLBD );
	INT_PTR nRet = dlg.ShowDlg();
	if( nRet == IDOK ){
		// f[^XV
		dlg.GetLBData( &isPath, pLBD );
		m_ctlLBItem.SetRedraw( FALSE );
		m_ctlLBItem.RenameItem( isPath, nSel );
		m_ctlLBItem.SetCurSel( nSel );
		m_ctlLBItem.SetRedraw( TRUE );
		LBResetEB();
	}

}


/////////////////////////////////////////////////////////////////////////////
// OnLstCommand()

void CMaryDelTreeExItemSettingDlg::OnLstCommand( WORD wCode )
{
	if( wCode == LBN_SELCHANGE ||
		wCode == LBN_SELCANCEL ||
		wCode == LBN_SETFOCUS ||
		wCode == LBN_KILLFOCUS )
	{
		iT(_T("Xg{bNXύXI[%i]\n"),wCode);
		LBResetEB();
	}
	else if( wCode == LBN_DBLCLK ){
		iT(_T("Xg{bNX _uNbNI\n"));
		OnBtnItemSetting();
	}


}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Xg{bNXɓpX邩`FbN

int CMaryDelTreeExItemSettingDlg::LBFindPath( LPCTSTR pPath )
{
	int nMax = m_ctlLBItem.GetItemCount();
	if( nMax <= 0 ){
		// XgɃACeȂ
		return -1;
	}

	CIkoStr isGetStr;
	int nRet = 0;
	int i = 0;

	while( i < nMax ){
		if( m_ctlLBItem.GetStr( &isGetStr, i ) ){
			if( isGetStr.CompareNC( pPath ) == 0 ){
				// v
				iT(_T("LBFindPath()>łɓĂ܂I\n"));
				return i;
			}
		}
		else{
			iT(_T("GetStr() sI\n"));
		}

		i++;
	}

	// vȂ
	return -1;
}


/////////////////////////////////////////////////////////////////////////////
// Xg{bNX̑IɉăGfBbg{bNXXV
/*
int nSel	IACeԍ
			-1 őIύXȂ
*/

void CMaryDelTreeExItemSettingDlg::LBResetEB( int nSel )
{
	if( nSel >= 0 ){
		m_ctlLBItem.SetCurSel( nSel );
	}

	if( nSel == -1 ){
		nSel = m_ctlLBItem.GetCurSel();
		if( nSel == -1 ){
			// IĂȂ
			SetWindowText( m_hEdtPath, _T("") );
			return;
		}
	}

	CIkoStr isGetStr;
	MARY_DLL_LB_DATA* pData = NULL;
	if( m_ctlLBItem.GetStr( &isGetStr, nSel, (LPVOID*)&pData ) ){
		// eLXg擾
		isGetStr += _T("\\");
		if( pData != NULL ){
			if( pData->isWC.IsEmpty() ){
				pData->isWC = _T("*.*");
			}
			isGetStr += pData->isWC;
		}
		SetWindowText( m_hEdtPath, isGetStr );
		// pX̍Ō\
		IkoEdtSetSel( m_hEdtPath, 0, -1 );
		IkoEdtSetSel( m_hEdtPath, -1, -1 );
	}
	else{
		// eLXg擾s
		SetWindowText( m_hEdtPath, _T("") );
	}

}


/////////////////////////////////////////////////////////////////////////////
// Xg{bNXɃf[^ǉ
/*
int LBAddStr( LPCTSTR psPath, int nNo = -1, LPCTSTR psWC = NULL, int nDelMode = 0 )
*/

int CMaryDelTreeExItemSettingDlg::LBAddStr( LPCTSTR psPath, int nNo, LPCTSTR psWC, int nDelMode )
{
	MARY_DLL_LB_DATA* pmdld = new MARY_DLL_LB_DATA;
	if( pmdld == NULL ){
		// new s
		IkoMsgBox( IDS_EX_SDMB_MES_3, IDS_STR_LABEL_TITLE, MB_OK, m_hWnd, NULL, g_hDllInst );
		return -1;
	}

	if( psWC != NULL ){
		pmdld->isWC = psWC;
	}

	if( pmdld->isWC.IsEmpty() ){
		pmdld->isWC = _T("*.*");
	}

	pmdld->uDelMode = nDelMode;


	int nSel = m_ctlLBItem.InsStr( psPath, nNo, pmdld );
	if( nSel == -1 ){
		// ǉG[
		IkoMsgBox( IDS_EX_SDMB_MES_2, IDS_STR_LABEL_TITLE, MB_OK, m_hWnd, NULL, g_hDllInst );
		return -1;
	}
	else if( nSel == -2 ){
		// ŗLf[^ǉG[
		IkoMsgBox( IDS_EX_SDMB_MES_4, IDS_STR_LABEL_TITLE, MB_OK, m_hWnd, NULL, g_hDllInst );
		delete pmdld;
		return -1;
	}


	return nSel;
}


/////////////////////////////////////////////////////////////////////////////
// WXgf[^Xg{bNXɓǂݍ

UINT CMaryDelTreeExItemSettingDlg::OnLoadRegData()
{
	// WXgf[^[h
	CIkoStr isRegDTERoot	= REG_MARY_EXTDLL;
	CIkoStr isRegDTEKey		= isRegDTERoot + _T("\\") + RE_DTEPATH;

	CIkoStr isExtItemNo;
	isExtItemNo.NumToStr( m_pMEI->nExtItemNo );
	isRegDTEKey += isExtItemNo;

	CIkoStr isDelPath;
	CIkoStr isDelWC;
	int nDelMode = 0;


	int nRet = 0;
	int i = 0;
	HKEY hKey = IkoRegOpenKey( isRegDTEKey, KEY_READ );
	if( hKey == NULL ){
		// WXgL[JȂ ܂
		return 0;
	}


	// ݔ`FbN RE_GOMIBAKO
	int nChkGB = 0;	// ftHg̓`FbNȂ
	if( IkoRegGetNum( hKey, RE_GOMIBAKO, &nChkGB ) != ERROR_SUCCESS ){
		// ǂݍ݃G[
		iT(_T("ݔ`FbNǂݍ߂܂I\n"));
	}
	IkoChkSetCheck( m_hChkGB, nChkGB );


	int nLoadRet = 0;
	BOOL bExist = TRUE;
	iT(_T("Xgf[^ [hJnI\n"),i+1);
	while( nRet != -1 ){
		iT(_T("Xgf[^ [h[%i]...\n"),i+1);

		nLoadRet = RegLoadData( hKey, i, &isDelPath, &isDelWC, &nDelMode );
		if( nLoadRet == -1 ){
			// GgȂ
			nLoadRet = 0;
			break;
		}
		else if( nLoadRet != 0 ){
			// G[
			break;
		}


		iT(_T("[hf[^[%i]...[%s][%s][%i]\n"),i+1,isDelPath.t(),isDelWC.t(),nDelMode);
		nRet = LBAddStr( isDelPath, -1, isDelWC, nDelMode );
		if( nRet == -1 ){
			// XgɃf[^ǉłȂ
			nLoadRet = IDS_EX_SDMB_MES_11;
			break;
		}

		i++;
	}


	IkoRegCloseKey( hKey );


	return nLoadRet;
}


/////////////////////////////////////////////////////////////////////////////
// WXgɃXg{bNXf[^ۑ

UINT CMaryDelTreeExItemSettingDlg::OnSaveRegData()
{
	CIkoStr isRegDTERoot	= REG_MARY_EXTDLL;
	CIkoStr isRegDTEKey		= isRegDTERoot + _T("\\") + RE_DTEPATH;
	CIkoStr isExtItemNo;
	isExtItemNo.NumToStr( m_pMEI->nExtItemNo );
	isRegDTEKey += isExtItemNo;


	// Xg̑ɂS~cȂ߂܂̓L[폜
	LONG lRet = IkoRegSHDelKey( isRegDTEKey );
	if( lRet == ERROR_SUCCESS || lRet == ERROR_FILE_NOT_FOUND ){
	}
	else{
		// 폜G[
//		IkoMsgBox( IDS_EX_SDMB_MES_6, IDS_STR_LABEL_TITLE, MB_OK|MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
		return IDS_EX_SDMB_MES_6;
	}

	int nItemCount = m_ctlLBItem.GetItemCount();
	if( nItemCount == -1 ){
		// XgACe擾łȂ
//		IkoMsgBox( IDS_EX_SDMB_MES_7, IDS_STR_LABEL_TITLE, MB_OK|MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
		return IDS_EX_SDMB_MES_7;
	}




	// Xg̃ACeƂݔ`FbNۑ
	UINT uSaveRet  = 0;
	CIkoStr isCount;
	CIkoStr isREPath;
	CIkoStr isREWC;
	CIkoStr isREDelMode;
	CIkoStr isPath;
	MARY_DLL_LB_DATA* pmdld = NULL;
	int i = 0;

	iT(_T("WXgL[[%s]\n"),isRegDTEKey.t());
	HKEY hKey = IkoRegCreateKey( isRegDTEKey, KEY_WRITE | KEY_READ );
	if( hKey == NULL ){
		// WXgL[쐬łȂ
		return IDS_EX_SDMB_MES_12;
	}


	// ݔ`FbN RE_GOMIBAKO
	int nChkGB = IkoChkGetCheck( m_hChkGB );
	if( IkoRegSetNum( hKey, RE_GOMIBAKO, nChkGB ) != ERROR_SUCCESS ){
		// ۑG[
		iT(_T("ݔ`FbNۑG[I[%i]\n"),nChkGB);
	}



	// Xg
	while( i < nItemCount ){
		iT(_T("Xgf[^ۑ[%i]/[%i]...\n"),i+1,nItemCount);

		if( !m_ctlLBItem.GetStr( &isPath, i, (LPVOID*)&pmdld ) ){
			// Xgf[^擾łȂ
//			IkoMsgBox( IDS_EX_SDMB_MES_8, IDS_STR_LABEL_TITLE, MB_OK|MB_ICONSTOP, m_hWnd, NULL, g_hDllInst );
			uSaveRet = IDS_EX_SDMB_MES_8;
			break;
		}

		isCount.NumToStr( i );
		isREPath		= RE_PATH;
		isREWC			= RE_PATH_WC;
		isREDelMode		= RE_PATH_DMODE;
		isREPath.PermStr( _T("|no|"), isCount );
		isREWC.PermStr( _T("|no|"), isCount );
		isREDelMode.PermStr( _T("|no|"), isCount );

		if( IkoRegSetStr( hKey, isREPath, isPath ) != ERROR_SUCCESS ){
			uSaveRet = IDS_EX_SDMB_MES_9;
			break;
		}
		if( IkoRegSetStr( hKey, isREWC, pmdld->isWC ) != ERROR_SUCCESS ){
			uSaveRet = IDS_EX_SDMB_MES_9;
			break;
		}
		if( IkoRegSetNum( hKey, isREDelMode, pmdld->uDelMode ) != ERROR_SUCCESS ){
			uSaveRet = IDS_EX_SDMB_MES_9;
			break;
		}

		i++;
	}


	IkoRegCloseKey( hKey );


	return uSaveRet;


}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// EBhEŉENbN

void CMaryDelTreeExItemSettingDlg::OnContextMenu( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	iTRACE(_T("}EXENbN (OnContextMenu)B\n"));
//	if( m_ctlLBItem.IsItemDrag() ){
//		// XgACehbO͉Ȃ
//		return;
//	}

	HWND hCtlWnd = (HWND)wParam;
	POINT ptPos = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };

	// ^Cgo[̏ȂVXej[\
	if( IkoIsPtInTitleBar( m_hWnd, &ptPos ) ){
		iTRACE("OnContextMenu()>^Cgo[ŃNbN܂B\n" );
		return;
	}
	else{
		HELPINFO hi;
		hi.cbSize = sizeof(HELPINFO);
		hi.iContextType = HELPINFO_WINDOW;
		hi.iCtrlId = GetDlgCtrlID( hCtlWnd );
		hi.hItemHandle = hCtlWnd;
		hi.dwContextId = 0;
		hi.MousePos = ptPos;

		OnHelp( hWnd, (LPARAM)&hi );
	}
}


/////////////////////////////////////////////////////////////////////////////
// F1 & [?] J[\ (󋵈ˑ) wv

BOOL CMaryDelTreeExItemSettingDlg::OnHelp( HWND hWnd, LPARAM lParam )
{
	iTRACE("[WM_HELP]\n");

	HELPINFO* phi = (HELPINFO*)lParam;
	HWND hCtlWnd = (HWND)phi->hItemHandle;

	iTRACE(_T("OnHelpInfo()>iCtrlId:[%i],dwContextId:[%i],MousePos:[%i],[%i]\n"),
		phi->iCtrlId, phi->dwContextId, phi->MousePos.x, phi->MousePos.y);

	// ̃_CAO`FbN
	HWND hParWnd = GetAncestor( hCtlWnd, GA_PARENT );
	if( hCtlWnd != m_hWnd && hParWnd != m_hWnd ){
		iTRACE(_T("OnHelpInfo()>̃_CAǑĂяoł͂܂B\n"));
		return FALSE;
	}

	int nCtrlID = 0;
	if( hCtlWnd == m_hWnd ){
		POINT ptCPt = phi->MousePos;
		ScreenToClient( m_hWnd, &ptCPt );
		HWND hPtWnd = ChildWindowFromPoint( m_hWnd, ptCPt );
		if( hPtWnd == NULL ){
			iTRACE(_T("ChildWindowFromPoint() sB\n"));
			return TRUE;
		}
		iTRACE(_T("OnHelpInfo()>_CAOB%i,%i,%i,%i\n"),
			phi->MousePos.x, phi->MousePos.y, ptCPt.x, ptCPt.y );
		if( hPtWnd == m_hWnd ){
			iTRACE(_T("OnHelpInfo()>eEBhEB\n"));
			return TRUE;
		}
		nCtrlID = GetDlgCtrlID( hPtWnd );
		hCtlWnd = hPtWnd;
	}
	else{
		nCtrlID = GetDlgCtrlID( hCtlWnd );
	}

	POINT ptPos = phi->MousePos;
	if( GetKeyState( VK_F1 ) < 0 ){
		iTRACE(_T("OnHelpInfo()>[F1] L[ɂĂяoB\n"));
		RECT rcItem = { 0, 0, 0, 0 };
		GetWindowRect( hCtlWnd, &rcItem );
		ptPos.x = rcItem.left;
		ptPos.y = rcItem.top;
	}

	iTRACE(_T(">nCtrlID>[%i]\n"),nCtrlID);

	UINT uID = 0;
	switch( nCtrlID ){
		case IDOK:
			uID = IDS_EX_HLP_SD_OK;
			break;
		case IDCANCEL:
			uID = IDS_EX_HLP_SD_CANCEL;
			break;
		case IDC_BTN_HELP:
			uID = IDS_EX_HLP_SD_BTN_HELP;
			break;
		case IDC_STC_WAIT:
		case IDC_EDT_WAIT:
		case IDC_SPN_WAIT:
			uID = IDS_EX_HLP_SD_WAIT;
			break;
		case IDC_CHK_SKIP:
			uID = IDS_EX_HLP_SD_SKIP;
			break;
		case IDC_CHK_OCHARUN:
			uID = IDS_EX_HLP_SD_OCHARUN;
			break;
		case IDC_STC_TITLE:
		case IDC_EDT_TITLE:
			uID = IDS_EX_HLP_SD_TITLE;
			break;
		case IDC_EDT_PATH:
			uID = IDS_EX_HLP_SD_EDT_PATH;
			break;
		case IDC_LST_ITEM:
			uID = IDS_EX_HLP_SD_LST_ITEM;
			break;
		case IDC_BTN_ADD:
			uID = IDS_EX_HLP_SD_BTN_ADD;
			break;
		case IDC_BTN_DEL:
			uID = IDS_EX_HLP_SD_BTN_DEL;
			break;
		case IDC_STC_ICON_GB:
		case IDC_CHK_GB:
			uID = IDS_EX_HLP_SD_CHK_GB;
			break;
	}


	// |bvAbvwv\
	if( uID != 0 ){
		IkoHelpPopupWnd( uID, g_hDllInst, &ptPos );
		return TRUE;
	}

	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
