/////////////////////////////////////////////////////////////////////////////
// Mary_DelTreeExItemSettingDlg.h

#pragma once
#include "Mary_DelTreeExListBox.h"

/////////////////////////////////////////////////////////////////////////////
// Mary_DelTreeExItemSettingDlg
// ڍאݒ_CAO

// vV[W
LRESULT CALLBACK Mary_DelTreeExItemSettingDlgProc(
	HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );


class CMaryDelTreeExItemSettingDlg
{
public:
	// th
	friend LRESULT CALLBACK Mary_DelTreeExItemSettingDlgProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

public:
	// RXgN^
	CMaryDelTreeExItemSettingDlg( HWND hWndParent = NULL );
	// fXgN^
	virtual ~CMaryDelTreeExItemSettingDlg();

public:
	// pubN\bh
	// }[nꂽf[^Zbg
	void SetMEI( MARY_EXTDLL_ITEMDATAW* pMEI );
	// _CAO쐬E\
	INT_PTR ShowDlg( void );
	// WM_MEASUREITEM
	void OnMeasureItem( UINT nCtlID, LPMEASUREITEMSTRUCT lpMeasureItemStruct );

	// WM_DRAWITEM Xg{bNX`
	void OnDrawItem( UINT nCtlID, LPDRAWITEMSTRUCT pdi );
	// WM_DESTROY
	void OnDestroy();


protected:
	// 
	virtual BOOL OnInit( HWND hWnd, LPARAM lParam );

	// WM_NOTIFY
	void OnNotify( WPARAM wParam, LPARAM lParam );

	// WM_PAINT
	void OnPaint();


	// t@Chbv
	void OnDropFiles( HDROP hDrop );
	// VXej[
	void OnSysCommand( WPARAM wParam, LPARAM lParam );
	// eR}h
	void OnCommand( WPARAM wParam, LPARAM lParam );
	// WM_KEYDOWN
	void OnKeyDown( WPARAM wParam, LPARAM lParam );


	// eRg[ƃEBhETCYύX
	void OnResizeCtlWnd();


	// [ۑ] {^
	void OnOK();
	// [LZ] {^
	void OnCancel();
	// [Web wv] {^
	void OnBtnHelp();

	// [ǉ] {^
	void OnBtnAdd();
	// [폜] {^
	void OnBtnDel();
	// [] {^ IꂽACe ()
	void OnBtnItemUp();
	// [] {^ IꂽACe ()
	void OnBtnItemDown();

	// XgACeڍאݒ
	void OnBtnItemSetting();

	// OnLstCommand()
	void OnLstCommand( WORD wCode );

	// Xg{bNXɓpX邩`FbN
	int LBFindPath( LPCTSTR psPath );
	// Xg{bNX̑IɉăGfBbg{bNXXV
	void LBResetEB( int nSel = -1 );
	// Xg{bNXɃf[^ǉ
	int LBAddStr( LPCTSTR psPath, int nNo = -1, LPCTSTR psWC = NULL, int nDelMode = 0 );

	// WXgf[^Xg{bNXɓǂݍ
	UINT OnLoadRegData();
	// WXgɃXg{bNXf[^ۑ
	UINT OnSaveRegData();

	// ENbNwv
	void OnContextMenu( HWND hWnd, WPARAM wParam, LPARAM lParam );

	// [F1] & [?] wv
	BOOL OnHelp( HWND hWnd, LPARAM lParam );



// vCx[goϐ
private:

	HWND	m_hWnd;				// EBhE
	HWND	m_hWndParent;		// I[i[EBhE

	HICON	m_hLabelIcon;		// xACR

	MARY_EXTDLL_ITEMDATAW*	m_pMEI;	// }[nf[^

	HWND	m_hBtnOK;			// [ۑ] {^
	HWND	m_hBtnCancel;		// [LZ] {^
	HWND	m_hBtnWebHelp;		// [Web wv] {^

	HWND	m_hStcWait;			// [ҋ@b] eLXg
	HWND	m_hEdtWait;			// [ҋ@b] GfBbg{bNX
	HWND	m_hSpnWait;			// [ҋ@b] XsRg[
	HWND	m_hChkSkip;			// [XLbv] `FbN{bNX
	HWND	m_hChkOchaRun;		// [] `FbN{bNX

	CIkoBmpCtl	m_hIBCIcon;		// [ACR]
	CIkoBmpCtl	m_hIBCIconGB;	// [ݔACR]
	HICON	m_hIconGB;			// ݔACR
	HWND	m_hChkGB;			// [ݔɂ] `FbN{bNX

	HWND	m_hStcTitle;		// [^Cg] eLXg
	HWND	m_hEdtTitle;		// [^Cg] GfBbg{bNX
	HWND	m_hGBList;			// [|Xg] O[v{bNX
	HWND	m_hEdtPath;			// [|tH_] GfBbg{bNX
	HWND	m_hBtnAdd;			// [ǉ] {^
	HWND	m_hBtnDel;			// [폜] {^
	HWND	m_hLCItem;			// Xg{bNX
	CDTEListBox	m_ctlLBItem;	// Xg{bNX

	HWND	m_hStcLine;			// 

	BOOL	m_bComInit;			// COM Ă TRUE

};


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
